/*  grtrace  (c) 2001 Brad Spengler  */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "tracehead.h"
#include "capdata.h"

int counter = 0;
int capcount = 0;
const char modestring[4][16]={"O_RDONLY","O_CREAT","O_WRONLY","O_APPEND"};
const char mode[4][2]={"r","w","w","a"};


extern void tracesort(void);

int checkdupe(char *filename, char mode)
{
	unsigned long i;
	for(i=0;i<counter;i++) {
		if(!strcmp(filename,acl[i].filename) &&
		strchr(acl[i].mode,mode))
			return -1;
		else if(!strcmp(filename,acl[i].filename) &&
		!strchr(acl[i].mode,mode))
			return i;
	}
	return counter;
}

int capact(char *capname)
{
	int i;
	for(i=0;i<capcount;i++) {
		if(!strcmp(caps[i],capname))
			return -1;
	}
	return capcount;
}

void findprocname(char *pid)
{
	char procentry[128];
	char buf[1024];
	char *p;
	FILE *procfile;
	snprintf(procentry,sizeof(procentry),"/proc/%s/maps",pid);
	procfile = fopen(procentry,"r");
	fgets(buf,sizeof(buf),procfile);
	p = buf + strlen(buf) - 1;
	*p = '\0';
	p = strchr(buf,'/');
	strncpy(procname,p,sizeof(procname));
}

void usage(char *basename)
{
	printf("usage: %s <-b|-p><binary|pid> <arg1> <arg2> <arg3> <...> <argn>\n",basename);
	printf("-b : make acl for binary, after this option should come name of binary and its arguments\n");
	printf("-p : make acl for running process, after this option should come the PID to attach to\n");
}

int main(int argc, char *argv[])
{
	char *p, *p2, *p3, *tp, *last, *pend;
	FILE *pstdin;
	int x,l;
	char command[1024];
	unsigned long i;
	int f = 0;

	if((argv[1] == NULL) || (argv[2] == NULL) || (strcmp(argv[1],"-p") && strcmp(argv[1],"-b"))) {
		usage(argv[0]);
		exit(1);
	}

	if(!strcmp(argv[1],"-p")) {
		findprocname(argv[2]);
		strcat(command,"/usr/bin/strace -p");
	} else
		strcat(command,"/usr/bin/strace");

	for(i=2;argv[i] != NULL;i++) {
			strcat(command," \"");
			strcat(command,argv[i]);
			strcat(command,"\"");
	}
	strcat(command," 2>&1");
	pstdin = popen(command,"r");
	i = 0;
	while(fgets(buf, sizeof(buf), pstdin)) {		
		if(!strncmp(buf, "execve(\"", 8) && (!i)) {
			p = buf + 8;
			pend = strchr(p, '\"');
			*pend = '\0';
			strncpy(procname, p, sizeof(procname));
		} else if(!strncmp(buf, "execve(\"", 8) && i) {
			p = buf + 8;
			pend = strchr(p, '\"');
			*pend = '\0';

			f = checkdupe(p,'x');
			if (f != -1) {
			strncpy(acl[f].filename, p,
			sizeof(acl[f].filename));
			strncat(acl[f].mode, "x",
			sizeof(acl[f].mode) - 
			strlen(acl[f].mode));
			}
			if(f == counter)
				counter++;
		} else if(!strncmp(buf, "open(\"", 6)) {
			p = buf + 6;
			p2 = p;
			pend = strchr(p, '\"');
			*pend = '\0';
			pend += 3;
			p = strchr(pend,'|');
			p3 = strchr(pend,')');
			*p3 = '\0';
			if(p < p3) {
				for(l=0,(tp = strtok_r(pend,"|",&last));tp;
				    (tp = strtok_r(NULL,"|",&last)),l++) {
					for(x=0;x<4;x++) {
					if(!strcmp(tp,modestring[x])) {
						f = checkdupe(p2, mode[x][0]);
						if(f != -1) {
							strcat(acl[f].mode, 
							mode[x]);
							strncpy(acl[f].filename, p2,
							sizeof(acl[f].filename));
						}
						if(f == counter)
							counter++;
					}
					}
				}
			} else {	
				for(x=0;x<4;x++) {
				if(!strcmp(pend,modestring[x])) {
					f = checkdupe(p2,mode[x][0]);
					if(f != -1) {
						strcat(acl[f].mode, 
						mode[x]);
						strncpy(acl[f].filename, p2,
						sizeof(acl[f].filename));
					}
					
					if(f == counter)
						counter++;
				}
				}
			}
		} else if(!strncmp(buf, "bind(", 5)) {
			p = buf + 5;
			pend = strchr(p, '(');
			pend++;
			p2 = strchr(pend, ')');
			*p2 = '\0';
			if ((atoi(pend) < 1024) && (atoi(pend) != 0)) {			
				f = capact("CAP_NET_BIND_SERVICE");
				if(f == capcount) {
					strncpy(caps[f],"CAP_NET_BIND_SERVICE",21);
					capcount++;
				}
			}
		} else {
			for(x=0;x<(sizeof(capid) / 96);x++) {
				if(capid[x][1][0] == '\0') {
					if(!strncmp(buf,capid[x][0],strlen(capid[x][0]))) {
						f = capact((char *)capid[x][2]);
						if(f == capcount) {
							strncpy(caps[f],capid[x][2],sizeof(caps[f]));
							capcount++;
						}
					}
				} else {
					if(!strncmp(buf,capid[x][0],strlen(capid[x][0])) &&
					   strstr(buf,capid[x][1])) {
						f = capact((char *)capid[x][2]);
						if(f == capcount) {
							strncpy(caps[f],capid[x][2],sizeof(caps[f]));
							capcount++;
						}
					}
				}
			}
		}
		i++;
	}

	tracesort();
	if(counter == 0)
		printf("Binary or PID does not exist, or did not do anything to make an ACL of.\n");
	else {
	printf("%s {\n",procname);
	for(i=0;i<counter;i++)
		printf("   %s   %s\n",acl[i].filename,acl[i].mode);
	for(i=0;i<capcount;i++)
		printf("   +%s\n",caps[i]);
	printf("}\n");
	}
	return 0;

}
